// HostEditDlg.cpp : t@C
//

#include "stdafx.h"
#include "WinWol.h"
#include "HostEditDlg.h"
#include "afxdialogex.h"
#include "GetIpDlg.h"
#include "GetMacAddrDlg.h"
#include "GetHostDlg.h"
#include "GlobalFunc.h"


// CHostEditDlg _CAO

IMPLEMENT_DYNAMIC(CHostEditDlg, CDialog)

CHostEditDlg::CHostEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHostEditDlg::IDD, pParent)
	, m_EdtHostName(_T(""))
	, m_EdtComment(_T(""))
	, m_EdtMacAddr(_T(""))
{
	m_IpAddr = _T("");
	m_NetMask = _T("255.255.255.0");
	m_TimeOut = ICMP_ECHO_TIME_OUT;
}

CHostEditDlg::~CHostEditDlg()
{
}

void CHostEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_HOST_NAME, m_EdtHostName);
	DDX_Text(pDX, IDC_EDIT_COMMENT, m_EdtComment);
	DDX_Text(pDX, IDC_EDIT_MAC_ADDR, m_EdtMacAddr);
	DDX_Control(pDX, IDC_IPADDRESS_IPADDR, m_CtlIpAddr);
	DDX_Control(pDX, IDC_IPADDRESS_NETMASK, m_CtlNetMask);
}


BEGIN_MESSAGE_MAP(CHostEditDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_SRCH_IP, &CHostEditDlg::OnBnClickedButtonSrchIp)
	ON_BN_CLICKED(IDC_BUTTON_ARP, &CHostEditDlg::OnBnClickedButtonArp)
	ON_NOTIFY(IPN_FIELDCHANGED, IDC_IPADDRESS_IPADDR, &CHostEditDlg::OnIpnFieldchangedIpaddressIpaddr)
	ON_BN_CLICKED(IDC_BUTTON_SRCH_HOSTNAME, &CHostEditDlg::OnBnClickedButtonSrchHostname)
END_MESSAGE_MAP()


// CHostEditDlg bZ[W nh[


BOOL CHostEditDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ɏǉĂ
	if (!m_IpAddr.IsEmpty()) {
		m_CtlIpAddr.SetAddress(StrToDwIpAddr((LPCTSTR)m_IpAddr));
	}	
	if (!m_NetMask.IsEmpty()) {
		m_CtlNetMask.SetAddress(StrToDwIpAddr((LPCTSTR)m_NetMask));
	}
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


void CHostEditDlg::OnOK()
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	DWORD	dwIpAddr;
	DWORD	dwNetMask;
	CString	msg;
	char	buf[256];

	UpdateData(TRUE);

#if 0
	if (m_EdtHostName.IsEmpty()) {
		msg.LoadString(IDS_STRING_ENTER_HOSTNAME);
		MessageBox(msg);
		return;
	}
	if (m_EdtMacAddr.IsEmpty()) {
		msg.LoadString(IDS_STRING_ENTER_MAC_ADDRESS);
		MessageBox(msg);
		return;
	}
#endif
	if (m_CtlIpAddr.GetAddress(dwIpAddr) < 4) {
		msg.LoadString(IDS_STRING_ENTER_IP_ADDRESS);
		MessageBox(msg);
		return;
	}
	m_IpAddr = DwToStrIpAddr(dwIpAddr, buf, sizeof(buf));

	if (m_CtlNetMask.GetAddress(dwNetMask) < 4) {
		dwNetMask = GetDefaultNetMask(dwIpAddr);
	}
	m_NetMask = DwToStrIpAddr(dwNetMask, buf, sizeof(buf));

	CDialog::OnOK();
}

void CHostEditDlg::OnBnClickedButtonSrchHostname()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	UpdateData(TRUE);

	DWORD	dwIpAddr;
	char	buf[256];

	if (m_CtlIpAddr.GetAddress(dwIpAddr) >= 4) {
		m_IpAddr = DwToStrIpAddr(dwIpAddr, buf, sizeof(buf));
	}
	CGetHostDlg	dlg;

	dlg.SetIpAddr(m_IpAddr);
	dlg.SetType(1);

	if (dlg.DoModal() == IDOK) {
		m_EdtHostName = dlg.GetHostName();
		UpdateData(FALSE);
	}
}

void CHostEditDlg::OnBnClickedButtonSrchIp()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	UpdateData(TRUE);

	DWORD	dwIpAddr;
	char	buf[256];

	if (m_CtlIpAddr.GetAddress(dwIpAddr) >= 4) {
		m_IpAddr = DwToStrIpAddr(dwIpAddr, buf, sizeof(buf));
	}
	CGetIpDlg	dlg;

	dlg.SetType(1);
	dlg.SetHostName((LPCTSTR)m_EdtHostName);
	dlg.SetIpAddr((LPCTSTR)m_IpAddr);

	if (dlg.DoModal() == IDOK) {
		m_IpAddr = dlg.GetIpAddr();
		m_CtlIpAddr.SetAddress(StrToDwIpAddr((LPCTSTR)m_IpAddr));

		dwIpAddr = StrToDwIpAddr((LPCTSTR)m_IpAddr);

		DWORD	dwNetMask = GetDefaultNetMask(dwIpAddr);
		m_CtlNetMask.SetAddress(dwNetMask);

		char	macaddr_str[32];
		if (IpAddrToMacAddr((LPCTSTR)m_IpAddr, macaddr_str, sizeof(macaddr_str))) {
			SetMacAddr(macaddr_str);
		}
		UpdateData(FALSE);
	}
}


void CHostEditDlg::OnBnClickedButtonArp()
{
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	DWORD	dwIpAddr;
	CString	msg;
	char	buf[256];

	UpdateData(TRUE);

	if (m_CtlIpAddr.GetAddress(dwIpAddr) >= 4) {
		m_IpAddr = DwToStrIpAddr(dwIpAddr, buf, sizeof(buf));
	}
	CGetMacAddrDlg	dlg;

	dlg.SetType(1);
	dlg.SetHost(m_IpAddr);
	dlg.SetTimeOut(m_TimeOut);

	if (dlg.DoModal() == IDOK) {
		CString	sMacAddr = dlg.GetMacAddr();

		SetMacAddr(sMacAddr);
		UpdateData(FALSE);
	}
}


void CHostEditDlg::OnIpnFieldchangedIpaddressIpaddr(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMIPADDRESS pIPAddr = reinterpret_cast<LPNMIPADDRESS>(pNMHDR);
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	DWORD	dwIpAddr;

	m_CtlIpAddr.GetAddress(dwIpAddr);

	DWORD	dwNetMask = GetDefaultNetMask(dwIpAddr);

	m_CtlNetMask.SetAddress(dwNetMask);

	*pResult = 0;
}

